# Get block deploys

Get deploys by block identifier (hash or height).

```
GET /blocks/{block_identifier}/deploys
```

## Query params

| Query param              | Description                                  |
| ------------------------ | -------------------------------------------- |
| `caller_public_key`      | Deploy caller public key                     |
| `contract_package_hash`  | Contract package hash of the called contract |
| `contract_hash`          | Called contract hash                         |
| `contract_entrypoint_id` | Called entry point ID                        |

## Sorting

| Property    | Description               |
| ----------- | ------------------------- |
| `timestamp` | Sort deploys by timestamp |

Default sorting is `timestamp DESC`

## Optional properties

| Property                   | Type                                                                                  | Description                                                                                                 |
| -------------------------- | ------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------- |
| `account_info`             | [`AccountInfo`](https://docs.cspr.cloud/rest-api/account-info)                        | [Account info](https://github.com/make-software/casper-account-info-contract) provided by the deploy caller |
| `centralized_account_info` | [`CentralizedAccountInfo`](https://docs.cspr.cloud/rest-api/centralized-account-info) | Account information available for known accounts provided by CSPR.cloud team                                |
| `caller_cspr_name`         | `string`                                                                              | Primary CSPR.name of the deploy caller account                                                              |
| `contract_package`         | [`ContractPackage`](https://docs.cspr.cloud/rest-api/contract-package)                | [`ContractPackage`](https://docs.cspr.cloud/rest-api/contract-package) called by deploy.                    |
| `contract`                 | [`Contract`](https://docs.cspr.cloud/rest-api/contract)                               | [`Contract`](https://docs.cspr.cloud/rest-api/contract) called by deploy.                                   |
| `contract_entrypoint`      | [`ContractEntrypoint`](https://docs.cspr.cloud/rest-api/contract-entry-point)         | [`ContractEntrypoint`](https://docs.cspr.cloud/rest-api/contract-entry-point) called by deploy.             |
| `rate`                     | `float32`                                                                             | CSPR rate for specified currency that was relevant at the moment of deploy creation.                        |
| `transfers`                | \[][`Transfer`](https://docs.cspr.cloud/rest-api/transfer)                            | List of `Transfer` entities.                                                                                |
| `nft_token_actions`        | \[] [`NFTTokenAction`](https://docs.cspr.cloud/rest-api/non-fungible-token-action)    | List of `NFTTokenAction` entities.                                                                          |
| `ft_token_actions`         | \[] [`FTTokenAction`](https://docs.cspr.cloud/rest-api/fungible-token-action)         | List of `Fungible token action` entities.                                                                   |

## Response

[`PaginatedResponse`](https://docs.cspr.cloud/documentation/overview/pagination)[`<Deploy>`](https://docs.cspr.cloud/rest-api/deploy)

## Example

```bash
curl -X 'GET' \
  'https://api.testnet.cspr.cloud/blocks/a6c2974d211fdf0ddadb15f4e81b2fb65a0274787c46f362301ef583764f26f4/deploys' \
  -H 'accept: application/json' \
  -H 'authorization: 55f79117-fc4d-4d60-9956-65423f39a06a'
```

```json
{
  "item_count": 1,
  "page_count": 1,
  "data": [
    {
      "args": {
        "accounts": {
          "cl_type": {
            "List": "Key"
          },
          "parsed": [
            {
              "Account": "account-hash-9081ded33b9d55aab6801da9c2fa5ce0750aee6eac158ae4989ee733def542f3"
            }
          ]
        },
        "deployment_threshold": {
          "cl_type": "U8",
          "parsed": 1
        },
        "key_management_threshold": {
          "cl_type": "U8",
          "parsed": 1
        },
        "weights": {
          "cl_type": {
            "List": "U8"
          },
          "parsed": [
            1
          ]
        }
      },
      "block_hash": "a6c2974d211fdf0ddadb15f4e81b2fb65a0274787c46f362301ef583764f26f4",
      "block_height": 2314748,
      "caller_hash": "277b0c7e95cac71a985b337de99c9bec5338272bbb99617b664e4ab1400639fb",
      "caller_public_key": "020267411749de2c7d7cf5f50ec2daad281b9a3029ec09d8a119ac7e65fa3422e0d8",
      "consumed_gas": "511166580",
      "contract_hash": "a97d0f3da70d0427b03bf61a53ce6f72b49c45b65c32a6226e1d322c6d533a86",
      "contract_package_hash": "dbebb9cfc57c727c03c4108142560642b7e1fcf732dcc0457889ef3dec435634",
      "cost": "511166580",
      "deploy_hash": "1fdea0ea6500652c814d7c2f4980309a21b87309f90d209cc8feb61ebd382d69",
      "entry_point_id": 2430820,
      "error_message": null,
      "execution_type_id": 2,
      "gas_price_limit": 1,
      "is_standard_payment": false,
      "payment_amount": "1000000000",
      "pricing_mode_id": 0,
      "refund_amount": "0",
      "runtime_type_id": 0,
      "status": "processed",
      "timestamp": "2023-12-22T13:14:43Z",
      "version_id": 0
    }
  ]
}
```
